QGIS Application - Bug report #7125
QgsVectorLayer::getFeatures returns no features if Exactintersect and NoGeometry used in

QgsFeatureRequest
2013-02-08 12:02 PM - Larry Shaffer

Status: Closed

Priority: High

Assignee: Martin Dobias

Category: Data Provider

Affected QGIS version:master Regression?: No
Operating System: Easy fix?: No
Pull Request or Patch supplied: Resolution:

Crashes QGIS or corrupls data: Copied to github as #: 16194
Description

Hi,

Recently, | updated the Show/Hide Label tool to work with new vector AP (commit:3676a38), but it should have worked before.

| could not use QgsFeatureRequest::Exactintersect | QgsFeatureRequest::NoGeometry when setting the flags in the
QgsVectorLayer::getFeatures's QgsFeatureRequest or no features were returned. Setting the flags to
QgsFeatureRequest::Exactintersect return the correct features. The call to QgsVectorLayer::getFeatures in this instance does not need to
return the geometries, as only the id is being collected from the returned features that intersect the given rectangle.

Associated revisions

Revision 19f06660 - 2013-02-09 10:59 PM - Jiirgen Fischer

fix #7125

History

#1 - 2013-02-08 12:44 PM - Juirgen Fischer

using which provider?

#2 - 2013-02-08 12:45 PM - Larry Shaffer
- Status changed from Open to Feedback

Postgres/PostGIS

#3 - 2013-02-08 12:48 PM - Larry Shaffer

Sorry, double-checked. The tested layer's source is a shapefile, not PostGIS. Will test with some others provider types.

#4 - 2013-02-09 12:32 PM - Juirgen Fischer

Larry Shaffer wrote:
Sorry, double-checked. The tested layer's source is a shapefile, not PostGIS. Will test with some others provider types.

And that yielded? Does https:/gist.github.com/jef-n/4747002 work for you?

#5 - 2013-02-09 01:23 PM - Larry Shaffer

Jurgen Fischer wrote:

Larry Shaffer wrote:

Sorry, double-checked. The tested layer's source is a shapefile, not PostGIS. Will test with some others provider types.

And that yielded? Does https.//qgist.github.com/jef-n/4747002 work for you?

There does not seem to be any related issue with PostGIS layers. The Show/Hide Label tool works fine for those.

After applying your QgsOgrFeaturelterator fix, the shapefile layers work fine, too (tested those layers right before applying the fix and they did not work).

Thanks for your help!

#6 - 2013-02-09 01:59 PM - Jiirgen Fischer
- Status changed from Feedback to Closed

Fixed in changeset commit:"19f06660dab2a426506ca84a7287aafe659b0df2".
